const fs = require("fs");
const path = require("path");
const Jimp = require('jimp');
var sizeOf = require('image-size');

// console.time("test");

const pwd = ".";
const target_str = '.assets';

// crop( x, y, w, h)
async function crop(x, y, width, height, i, element, pic) {
    // 读取图片
    const image = await Jimp.read(pic);
    // await image.crop(0, 0, 1000, 150);
    await image.crop(x, y, width, height);
    // 保存
    // image-20220225173606089.png
    // image-20220225173606089
    await image.writeAsync(`${element.split(".")[0]}/${i}.png`);
    console.log('图片已经切完了一张。');
}


fs.readdir(pwd, function (err, files) {
    if (err) {
        return console.log(err);
    } else {
        files.forEach(function (item) {
            // console.log(item);
            if (item.indexOf(target_str) != -1) {
                dir_name = item;
                // dir_name就是工作目录下的'.assets'图片文件夹
                fs.readdir(path.join(pwd, dir_name), function (err, files) {
                    if (err) {
                        return console.log(err);
                    } else {
                        // console.log(files);
                        file_name = dir_name.split(target_str)[0] + ".md";
                        for (let i = 0; i < files.length; i++) {
                            const element = files[i];
                            // console.log(element);
                            // console.log(element.split(".")[0]);
                            if (fs.readdirSync(pwd).includes(element.split(".")[0]) == false) {
                                // console.log(element.split(".")[0]);
                                let dir_path = element.split(".")[0]
                                // fs.mkdir(path.join(pwd, dir_path), function (err) {
                                //     if (err) {
                                //         return console.log(err);
                                //     } else {
                                //         console.log(`${dir_path}文件夹创建完成`);
                                //     }
                                // })
                                fs.mkdirSync(path.join(pwd, dir_path));
                                console.log(`${dir_path}文件夹创建完成`);
                            }
                            // 传入图片的相对路径。
                            // path.join(dir_name, element);
                            console.log(path.join(dir_name, element));
                            // 传入图片的相对路径。
                            var pic = path.join(dir_name, element);
                            var dimensions = sizeOf(pic);
                            img_y = dimensions.width > 1200 ? dimensions.width / 35 : 1200 / 35;

                            for (let i = 0; dimensions.height - img_y * i > 0; i++) {
                                if (dimensions.height - img_y * i > img_y) {
                                    crop(0, img_y * i, dimensions.width, img_y, i, element, pic);
                                } else {
                                    crop(0, img_y * i, dimensions.width, dimensions.height - img_y * i, i, element, pic);
                                }

                            }
                            // console.log("图片切完了一张。");
                            // console.log("图片全都切完了。");
                            //puls_str(file_name);
                        }
                        // console.log("任务已经完成了。");
                        // console.timeEnd("test");
                    }
                });
            }
        });
    }
});